searchNodes=[{"doc":"","ref":"Example.html","title":"Example","type":"module"},{"doc":"","ref":"Example.html#double/1","title":"Example.double/1","type":"function"},{"doc":"","ref":"Example.html#function_with_26_arguments/26","title":"Example.function_with_26_arguments/26","type":"function"},{"doc":"","ref":"Example.html#function_with_multiple_arities/1","title":"Example.function_with_multiple_arities/1","type":"function"},{"doc":"","ref":"Example.html#function_with_multiple_arities/2","title":"Example.function_with_multiple_arities/2","type":"function"},{"doc":"","ref":"Example.html#function_with_multiple_arities/3","title":"Example.function_with_multiple_arities/3","type":"function"},{"doc":"","ref":"Fake.html","title":"Fake","type":"module"},{"doc":"","ref":"Fake.html#delegate/1","title":"Fake.delegate/1","type":"function"},{"doc":"","ref":"Fake.html#example/1","title":"Fake.example/1","type":"function"},{"doc":"Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made. Using Patch is as easy as adding a single line to your test case. use Patch After this all the patch functions will be available, see the README and function documentation for more details.","ref":"Patch.html","title":"Patch","type":"module"},{"doc":"Asserts that the function has been called with any arity call","ref":"Patch.html#assert_any_call/2","title":"Patch.assert_any_call/2","type":"function"},{"doc":"","ref":"Patch.html#assert_called/1","title":"Patch.assert_called/1","type":"macro"},{"doc":"Fakes out a module with an alternative implementation. The real module can still be accessed with real/1. For example, if your project has the module Example.Datastore and there&#39;s a fake available in the testing environment named Example.Test.InMemoryDatastore the following table describes which calls are executed by which code before and after faking with the following call. fake(Example.Datastore, Example.Test.InMemoryDatastore) Calling CodeResponding Module before fake/2Responding Module after fake/2 Example.Datastore.get/1Example.Datastore.get/1Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1Example.Test.InMemoryDatastore.get/1Example.Test.InMemoryDatastore.get/1 real(Example.Datastore).get/1(UndefinedFunctionError)Example.Datastore.get/1 The fake module can use the renamed module to access the original implementation.","ref":"Patch.html#fake/2","title":"Patch.fake/2","type":"function"},{"doc":"Patches a function in a module The patched function will either always return the provided value or if a function is provided then the function will be called and its result returned.","ref":"Patch.html#patch/3","title":"Patch.patch/3","type":"function"},{"doc":"","ref":"Patch.html#real/1","title":"Patch.real/1","type":"function"},{"doc":"Refutes that the function has been called with any arity call","ref":"Patch.html#refute_any_call/2","title":"Patch.refute_any_call/2","type":"function"},{"doc":"","ref":"Patch.html#refute_called/1","title":"Patch.refute_called/1","type":"macro"},{"doc":"Remove any mocks or spies from the given module","ref":"Patch.html#restore/1","title":"Patch.restore/1","type":"function"},{"doc":"Spies on the provided module Once a module has been spied on the calls to that module can be asserted / refuted without changing the behavior of the module.","ref":"Patch.html#spy/1","title":"Patch.spy/1","type":"function"},{"doc":"Meck wants functions as mocks, this module assists in creating functions of any arity. mix format wants this to be several thousand lines long, so it&#39;s getting put over here to keep the main Patch module small and easy to read. TODO: Find a better way to do this.","ref":"Patch.Function.html","title":"Patch.Function","type":"module"},{"doc":"Generate an anonymous function of the arity provided that calls the provided factory function with the arguments as a list. BEAM only supports functions of arity /0 though /254.","ref":"Patch.Function.html#for_arity/2","title":"Patch.Function.for_arity/2","type":"function"},{"doc":"","ref":"Real.html","title":"Real","type":"module"},{"doc":"","ref":"Real.html#delegate/1","title":"Real.delegate/1","type":"function"},{"doc":"","ref":"Real.html#example/1","title":"Real.example/1","type":"function"},{"doc":"","ref":"Patch.MissingCall.html","title":"Patch.MissingCall","type":"exception"},{"doc":"","ref":"Patch.UnexpectedCall.html","title":"Patch.UnexpectedCall","type":"exception"},{"doc":"Patch Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made.","ref":"readme.html","title":"Patch","type":"extras"},{"doc":"Add patch to your mix.exs def deps do [ {:patch, &quot;~&gt; 0.3&quot;, only: [:test]} ] end","ref":"readme.html#installation","title":"Patch - Installation","type":"extras"},{"doc":"After adding the dependency just add the following line to any test module after using your test case use Patch","ref":"readme.html#quickstart","title":"Patch - Quickstart","type":"extras"},{"doc":"When a module is patched, the patched function will return the value provided. defmodule PatchExample do use ExUnit.Case use Patch test &quot;functions can be patched to return a specified value&quot; do assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, :patched_return_value) assert :patched_return_value == String.upcase(&quot;hello&quot;) # Assertion passes after patching end end Modules can also be patched to run custom logic instead of returning a static value defmodule PatchExample do use ExUnit.Case use Patch test &quot;functions can be patched with a replacement function&quot; do assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, fn s -&gt; String.length(s) end) assert 5 == String.upcase(&quot;hello&quot;) # Assertion passes after patching end end Patching Ergonomics patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example defmodule PatchExample do use ExUnit.Case use Patch test &quot;patch returns the patch&quot; do {:ok, expected} = patch(My.Module, :some_function, {:ok, 123}) # ... additional testing code ... assert response.some_function_result == expected end end This allows the test author to combine creating fixture data with patching.","ref":"readme.html#patches","title":"Patch - Patches","type":"extras"},{"doc":"After a patch is applied, tests can assert that an expected call has occurred by using the assert_called macro. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting calls on a patch&quot; do patch(String, :upcase, :patched_return_value) assert :patched_return_value = String.upcase(&quot;hello&quot;) # Assertion passes after patching assert_called String.upcase(&quot;hello&quot;) # Assertion passes after call end end assert_called supports the :_ wildcard atom. In the above example the following assertion would also pass. assert_called String.upcase(:_) This can be useful when some of the arguments are complex or uninteresting for the unit test. Tests can also refute that a call has occurred with the refute_called macro. This macro works in much the same way as assert_called and also supports the :_ wildcard atom. defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting calls on a patch&quot; do patch(String, :upcase, :patched_return_value) assert &quot;h&quot; == String.at(&quot;hello&quot;, 0) refute_called String.upcase(&quot;hello&quot;) end end Multiple Arities If a function has multiple arities that may be called based on different conditions the test author may wish to assert or refute that a function has been called at all without regards to the number of arguments passed. This can be accomplished with the assert_any_call/2 and refute_any_call/2 functions. These functions take two arguments the module and the function name as an atom. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting any call on a patch&quot; do patch(String, :pad_leading, fn s -&gt; s end) # This formatting call might provide custom padding characters based on # time of day. (This is an obviously constructed example). TimeOfDaySensitiveFormatter.format(&quot;Hello World&quot;) assert_any_call String, :pad_leading end end Similarly we can refute any call defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting any call on a patch&quot; do patch(String, :pad_leading, fn s -&gt; s end) assert {:error, :not_a_string} = TimeOfDaySensitiveFormatter.format(123) refute_any_call String, :pad_leading end end","ref":"readme.html#asserting-refuting-calls","title":"Patch - Asserting / Refuting Calls","type":"extras"},{"doc":"If a test wishes to assert / refute calls that happen to a module without actually changing thebehavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls and return values are recorded so assert_called/1, refute_called/1, assert_any_called/2, and refute_any_called/2 work as expected.","ref":"readme.html#spies","title":"Patch - Spies","type":"extras"},{"doc":"Sometimes we want to replace one module with another for testing, for example we might want to replace a module that connects to a real datastore with a fake that stores data in memory while providing the same API. The fake/2,3 functions can be used to replace one module with another. The replacement module can be completely stand alone or can utilize the functionality of the replaced module, it will be made available through use of the real/1 function. defmodule HighLatencyDatabase do @latency System.convert_time_unit(20, :second, :microsecond) def get(id) do {elapsed, response} = :timer.tc(fn -&gt; Patch.real(Database).get(id) end) induce_latency(elapsed) response end defp induce_latency(elapsed) when elapsed &lt; @latency do time_to_sleep = System.convert_time_unit(@latency - elapsed, :microsecond, :millisecond) Process.sleep(time_to_sleep) end defp induce_latency(_), do: :ok end This fake module uses the real module to actually get the record from the database and then makes sure that a minimum amount of latency, in this case 20 seconds, is introduced before returning the result.","ref":"readme.html#fakes","title":"Patch - Fakes","type":"extras"}]